package pep;

import java.lang.Math.*;

/**This class defines the operations of Identity nodes.*/
public class Identity extends Node{
 /**Total amount of input*/
 public static double[] totInput = new double[Main.nSubjects];

 /**Creates a new Identity node.
  * @param subject Subject number used for static variable array.*/
 public Identity(int subject){
  super(subject);
  threshold = .3;
  strength = .6;
 }

 /**Updates activation for each cycle and searches responses.
  * @param stimNum Stimulus number.*/
 public void activate(int stimNum){
  //5% interference between nodes
  input = range(input-((totInput[subj]-input)*.05));
  update();
  if(activation>threshold){
   double output = (activation-threshold)*java.lang.Math.random()*strength*5;
   Main.runs[subj].responses[stimNum].input += output;
   // <- insert asterix to lesion
   strength = strength*.9999 + .0001;//*/ strength = .75;
  }
 }

 /**Clears total input for next cycle.
  * @param subject Subject number used for static variable array.*/
 public static void clear(int subject){
  totInput[subject] = 0;
 }
}