package pep;

/**This Node subclass defines the operations of Response nodes.*/
public class Response extends Node{
 /**Amount of activation retrieved*/ public double retrieved;
 /**Total amount memory retrieved*/
 public static double[] totRetrieved = new double[Main.nSubjects];
 public double ret = 0;

 /**Creates a new Response node.
  * @param subject Subject number used for static variable array.*/
 public Response(int subject){
  super(subject);
  threshold = .45;
  retrieved = 0;
 }

 /**Updates response activation.*/
 @Override
 public void activate(){
  retrieve();
  update();
 }

 /**Adds retrieved activation to input.*/
 private void retrieve(){
  if(totRetrieved[subj]>0){
   ret = retrieved;
   //subtract average input to other nodes
   ret -= ((totRetrieved[subj]-retrieved)/(Main.nResponses-1));
   //input proportional if total retrieved exceeds 1
   if(totRetrieved[subj]>1) ret /= totRetrieved[subj];
   //small threshold
   ret -= .1;
   //range result between 0 and .1
   ret = range(ret,.1);
   //add retrieval input
   input += ret;
   retrieved = 0;
  }
 }

 /**Clears totRetrieved for the next cycle.
  * @param subject Subject number used for static variable array.*/
 public static void clear(int subject){
  totRetrieved[subject] = 0;
 }
}